function [M]=cpa1(original,distorted,a_lpha,b_eta)
%30/11/09
%original - original image
%distorted - distorted image
%a_lpha,b_eta - Minkowski parameters
%------------------------------------
% converting rgb to grayscale image
if isrgb(original)
        original=rgb2gray(original);
end
if isrgb(distorted)
    distorted=rgb2gray(distorted);
end
%------------------------------------
%making the image size odd
[d1 d2]=size(original);
% if mod(d1,2)==0
%     original=original(1:d1-1,:);
%     distorted=distorted(1:d1-1,:);
% end
% if mod(d2,2)==0
%     original=original(:,1:d2-1);
%     distorted=distorted(:,1:d2-1);
% end
%if mod(d1,2)==0
%    original(d1+1,:)=original(d1,:);
%    distorted(d1+1,:)=distorted(d1,:);
%end
%if mod(d2,2)==0
%    original(:,d2+1)=original(:,d2);
%    distorted(:,d2+1)=distorted(:,d2);
%end
%
%[d1 d2]=size(original);

%------------------------------------

csf=csf_a(d2,d1);csf_norm=csf./(max(csf(:)));%normalized CSF
FA=fftshift(fft2(original));FB=fftshift(fft2(distorted));
FAcsf=FA.*csf_norm;FBcsf=FB.*csf_norm;
origIFFT = ifft2(ifftshift(FAcsf));distIFFT=ifft2(ifftshift(FBcsf));
spatialErr=origIFFT-distIFFT;
spatialErr=abs(spatialErr);
s_ize=numel(spatialErr);
M=((sum(sum(spatialErr.^a_lpha)))/s_ize)^(1/b_eta);




%---------------------------

function csf=csf_a(l,h)
% par Patrick Le Callet
% cette fonction renvoie la csf pour la composante achromatique
% en fait csf de Daly

peak_sensitivity=250;
excentricite = 0;
luminance_adaption = 100;
%dcalage +1 li au recentrage de la composante continu du spectre
offset0l=l/2+1;
offset0h=h/2+1;

%coefficient de normalisation de la frquence/spectre
delta0l=1/l;
delta0h=1/h;

nppd = 60;
i2 =  h*l/(nppd^2);
a = 0.801*(1.7/luminance_adaption)^-0.2;
b = 0.3*(101/luminance_adaption)^0.15;
epsi = 0.9;
ra = 0.856*2.5^0.14;
re = 1/(1+0.24*excentricite);


i=1:1:offset0l;
j=1:1:offset0h;
fl= i*delta0l;
fc= j*delta0h;
[Fl,Fc]=meshgrid(fl,fc);
% multiplication par un facteur 60 pour cpd
w1 = 60*sqrt(Fl.^2+Fc.^2);
teta = atan2(Fl,Fc);
rteta = 0.11*cos(4*teta) + 0.89;
w2 = w1./(ra*re*rteta);

cs1 = ((3.23*(i2*w1.^2).^-0.3).^5 + 1).^-0.2;
cs2 = a*epsi*(cs1.*w1).*exp(-b*epsi*w1);
csf1 = cs2.*(1+0.06*exp(b*epsi*w1)).^0.5;

cs1 = ((3.23*(i2*w2.^2).^-0.3).^5 + 1).^-0.2;
cs2 = a*epsi*(cs1.*w2).*exp(-b*epsi*w2);
csf2 = cs2.*(1+0.06*exp(b*epsi*w2)).^0.5;


csf3 = min(real(csf1),real(csf2));
maxi = max(max(csf3));
csf3 = csf3/maxi;

csf = zeros(h,l);
csf(offset0h-1:h,offset0l-1:l) = csf3;
csf(1:offset0h,offset0l-1:l) = flipud(csf3);
csf(1:offset0h,1:offset0l) = fliplr(flipud(csf3));
csf(offset0h-1:h,1:offset0l) = fliplr(csf3);
csf = peak_sensitivity*csf;